Index: libcfa/src/concurrency/alarm.cfa
===================================================================
--- libcfa/src/concurrency/alarm.cfa	(revision c5e1aa6010a41c286b6f179da6348411941b89b2)
+++ libcfa/src/concurrency/alarm.cfa	(revision 579427b5dae492c357e172f3e2f17af585f77f00)
@@ -10,6 +10,6 @@
 // Created On       : Fri Jun 2 11:31:25 2017
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Wed Jun 17 16:11:35 2020
-// Update Count     : 75
+// Last Modified On : Thu Apr 24 22:22:25 2025
+// Update Count     : 88
 //
 
@@ -84,14 +84,7 @@
 
 void insert( alarm_list_t * this, alarm_node_t * n ) {
-	alarm_node_t * it = & (*this)`first;
-	while( it && (n->deadline > it->deadline) ) {
-		it = & (*it)`next;
-	}
-	if ( it ) {
-		insert_before( *it, *n );
-	} else {
-		insert_last(*this, *n);
-	}
-
+	alarm_node_t & it = iter( *this );
+	while ( advance( it ) && it.deadline <= n->deadline );
+	insert_before( it, *n );
 	verify( validate( *this ) );
 }
@@ -99,5 +92,5 @@
 alarm_node_t * pop( alarm_list_t * this ) {
 	verify( validate( *this ) );
-	alarm_node_t * head = & (*this)`first;
+	alarm_node_t * head = &first( *this );
 	if( head ) {
 		remove(*head);
@@ -147,7 +140,7 @@
 	park();
 
-	/* paranoid */ verify( !node.set );
-	/* paranoid */ verify( & node`next == 0p );
-	/* paranoid */ verify( & node`prev == 0p );
+	/* paranoid */ verify( ! node.set );
+	/* paranoid */ verify( & next( node ) == 0p );
+	/* paranoid */ verify( & prev( node ) == 0p );
 }
 
Index: libcfa/src/concurrency/barrier.hfa
===================================================================
--- libcfa/src/concurrency/barrier.hfa	(revision c5e1aa6010a41c286b6f179da6348411941b89b2)
+++ libcfa/src/concurrency/barrier.hfa	(revision 579427b5dae492c357e172f3e2f17af585f77f00)
@@ -11,6 +11,6 @@
 // Created On       : Sun Nov 10 08:07:35 2024
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Wed Nov 13 12:37:04 2024
-// Update Count     : 9
+// Last Modified On : Thu Apr 24 22:41:11 2025
+// Update Count     : 12
 // 
 
@@ -31,6 +31,6 @@
 
 // Returns a value indicating the reverse order the threads arrived, i.e. last thread returns 0 (and does not block)
-// last is an optional hook that is called by the Gth thread before unblocking the other threads.
-static inline unsigned int block( barrier & mutex b, fptr_t last = (fptr_t)0 ) with( b ) {
+// hook is an optional hook that is called by the Gth thread before unblocking the other threads.
+static inline unsigned int block( barrier & mutex b, fptr_t hook = (fptr_t)0 ) with( b ) {
 	arrivals -= 1;										// prefix decrement so last is 0 not 1
 	unsigned arrived = b.arrivals;						// note arrival order
@@ -38,5 +38,5 @@
 		wait( b.c );
 	} else {											// group formed
-		if ( last ) last();								// safe to call
+		if ( hook ) hook();								// safe to call
 		signal_all( c );								// unblock group
 		arrivals = group;								// reset
